//Exemple de chargement de classes qui se trouvent dans un repertoire "classes"
//
//
import java.lang.*;
import java.lang.reflect.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class ExempleCh08_02Cas1
{
    public static void main(String... args) throws Exception
    {
        System.out.println("Execution de ExempleCh08_02 CAS 1");

        // Cas 1.1
        // -------
        System.out.println("-------------------------");
        System.out.println("Dans ce sous-cas, le chargeur de classe n'est pas passe en parametre de lancement de la JVM.\nMais cree dans le programme.\nFonctionne dans tous les cas.");
        Class<?> classe1 = new ChargeurDefaut(ClassLoader.getSystemClassLoader()).loadClass("Exemple");
        ExempleInt ex = (ExempleInt) classe1.newInstance();
        System.out.println(ex.traitement("CAS 1.1 : appel du traitement"));

        // Cas 1.2
        // -------
        System.out.println("-------------------------");
        System.out.println("Dans ce sous-cas, le chargeur de classe est pass en parametre de lancement de la JVM.\nLe chargeur de classe est cree par la JVM.\nNe fonctionne donc pas sans ce parametre.");
        Class<?> classe2 = Class.forName("Exemple",true, 
                                         ClassLoader.getSystemClassLoader());
        ExempleInt ex2 = (ExempleInt) classe2.newInstance();
        System.out.println(ex2.traitement("CAS 1.2 : appel du traitement"));

        // Cas 1.3
        // -------
        System.out.println("-------------------------");
        System.out.println("Les sous-cas precedents utilises une interface. Ici, pas d'interface donc utilisation de la reflexivite de Java pour executer le traitement.\nIci, la classe Bonjour est utilise.");
        Class<?> classe = 
            Class.forName("Bonjour",true, 
                          ClassLoader.getSystemClassLoader());
                
        Method m = classe.getMethod("main",new Class[]{String[].class});
        
        String[] tabargs = new String[2];
        tabargs[0] = args[0];
        tabargs[1] = args[1];
        Object[] params = new Object[1];
        params[0] = tabargs;
        m.invoke(null, params);
        System.out.println("La classe Individu est charge a travers le classpath.");
    }
}
