import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.lang.reflect.*;

public class ExempleOD extends UnicastRemoteObject implements ExempleODInt
{
    public ExempleOD() throws Exception
    {
        super(9101);
        System.out.println("Execution de l'OD sur le port 9101");
        
        try{
            LocateRegistry.createRegistry(9100);
            System.out.println("Execution du LocateRegistry sur le port 9100");
        } catch(Exception ex){};

        Naming.rebind("rmi://localhost:9100/EXEMPLEOD",this);
    }
    
    public ResultatInt traitement(Class<?> classeBonjourInt,
                                  IndividuInt individu,
                                  String texte) throws RemoteException
    {
        System.out.println("Execution du traitement");

        Class[] parameter = new Class[1];
        parameter[0] = String.class;
        try{
            Constructor constr = classeBonjourInt.getConstructor(parameter);
            BonjourInt bonjour = (BonjourInt)(constr.newInstance(texte));
            bonjour.dire(individu);
        }catch(Exception ex){ex.printStackTrace();}
        
        return new Resultat("Traitement realise");
    }
            
}